%% script2

%% fit ray errors

clear;
load rayfan_f2doublet

yfit =  [ y y.^3 y.^5 y.^7 y.^9 ];
sz=size(yfit);
n = sz(2);
rtable = zeros(n,n);
close all
for k=1:n
    c = yfit(:,1:k)\dy;
    rtable(k,1:k)=c';
    yf = yfit(:,1:k)*c;
    subplot(3,2,k);
    %plot(y,dy,y,yf);
    fanplot(y,[dy yf]);
    title(sprintf('order %d',2*k-1));
end
rtable

%%
% quality of fit

close all;
order = 1:2:9;
qual = zeros(size(order));
ref = max(abs(dy));
for k=1:length(order)
    c = rtable(k,1:k)';
    yf = yfit(:,1:k)*c;
    diff = dy - yf;
    qual(k) = max(abs(diff))/ref;
end
stem(order,qual,'k','LineWidth',2);
grid;
xlabel('order');
ylabel('maximum relative difference');
axis([0 10 0 1]);

    

%% fit opd

yfit =  [ ones(size(y)) y.^2 y.^4 y.^6 y.^8 y.^10];
sz=size(yfit);
n = sz(2);
table = zeros(n,n);
for k=1:n
    c = yfit(:,1:k)\opd;
    table(k,1:k)=c';
    yf = yfit(:,1:k)*c;
    subplot(3,2,k);
    %plot(y,opd,y,yf);
    fanplot(y,[opd yf],10);
    title(sprintf('order %d',2*k-2));
end
table

%%
% quality of fit

close all;
order = 0:2:10;
qual = zeros(size(order));
ref = max(abs(opd));
for k=1:length(order)
    c = table(k,1:k)';
    yf = yfit(:,1:k)*c;
    diff = opd - yf;
    qual(k) = max(abs(diff))/ref;
end
stem(order,qual,'k','LineWidth',2);
grid;
xlabel('order');
ylabel('maximum relative difference');
axis([0 12 0 1]);


%% get OPD from ray error

fact = [2 4 6 8 10 ];
fact = ones(size(fact'))*fact;

% ua for f/2 system
ua = 0.25;
lambda = 0.5876e-3;
epsilon = lambda/ua;
ifact = (1./fact);
otable = -rtable.*ifact/epsilon;
otable

%%

% show differences
for k=1:4
    subplot(2,2,k);
    n = k+1;
    c = table(n,1:n)';
    y1 = yfit(:,1:n)*c;
    c = [0; otable(k,1:k)'];
    y2 = yfit(:,1:k+1)*c;
    fanplot(y,[opd y1 y2],10);
    title(sprintf('order %d',2*k+2));
end

%%
% Integrating the ray error fit to get an OPD fit
% does not work well unless the quality of fit is good.

